function ShowSolution(nodes,elem,u);
%ShowSolution(...)
%  shows a graph of a numerical solution of the PDE
%
%ShowSolution(nodes,elem,u);
%nodes, elem contain information about the mesh
%         see ReadMesh() for the description of the format
%u   contains the values of the solution at the nodes
%
%see also ReadMesh, ShowMesh, FEMEquation, FEMSolve, FEMValue


% the current version uses compiled code to write data to disk, 
% to be read by Gnuplot

if (nargin!=3) 
  help("ShowSolution");
  usage("ShowSolution(nodes,elem,u)");
endif

WriteSolution(nodes,elem,u);  # this is reasonably fast

%gset title "The Solution"
gset view 60, 30
% gsplot  "/tmp/meshdata.gnu" with lines 3 ,"/tmp/meshdata.gnu" with points 12
eval("gsplot  \"/tmp/meshdata.gnu\" with lines 3");

% bad idea to remove the data file, replot will not work
% unique file names shoud be created and then removed at the end of the session
% system("rm /tmp/meshdata.gnu");

endfunction

