if(!exist("square.1.node","file"))
   xy=[1,0,1;0,1,1;-1,0,1;0,-1,1];
   CreateMeshTriangle("square",xy,0.01)
endif

[nodes,elem,edges]=ReadMeshTriangle("square.1");
eval("gset nokey");
# ShowMesh(nodes,elem);

function res = BC(xy)
  res=abs(xy(:,1));
endfunction

[A,b,n2d]=FEMEquation(nodes,elem,edges,1,0,0,'BC',0);
u=FEMSolveSym(nodes,A,b,n2d,'BC');

area0=FEMIntegrate(nodes,elem,1)

numit=5;
errors=zeros(numit,1);
areas=errors;

for it=1:numit
  norm=FEMIntegrate(nodes,elem,u.^2);
  ugrad=FEMGradient(nodes,elem,u);
  coeff=sqrt(1+ugrad(:,1).^2+ugrad(:,2).^2);
  areas(it)=FEMIntegrate(nodes,elem,coeff);
  coeff=1./coeff;
  uold=u;
  [A,b,n2d]=FEMEquation(nodes,elem,edges,coeff,0,0,'BC',0);
  u=FEMSolveSym(nodes,A,b,n2d,'BC');
  errors(it)=FEMIntegrate(nodes,elem,(u-uold).^2);
endfor
[areas,errors]
figure(1);
ShowSolution(nodes,elem,u-uold);
figure(2);
ShowSolution(nodes,elem,u);

%purge_tmp_files

