#include <iostream.h>
#include <math.h>

#include <octave/oct.h>

#include <octave/parse.h>

DEFUN_DLD (fF, args, , "[...] = fF (...) bla ")
{
  octave_value_list retval;
  int nargin = args.length ();
  if (nargin >1 ) {
    print_usage ("fF");
    return retval;
  }

  octave_value X_arg = args(0);
  int nr= X_arg.rows();
  ColumnVector result (nr);

  for(int i= 0; i < nr; i++) {
    result(i)=0.0;
  }

  retval(0)=result;
  
  return retval;
}

DEFUN_DLD (aF, args, , "[...] = aF (...) bla ")
{
  octave_value_list retval;
  int nargin = args.length ();
  if (nargin >1 ) {
    print_usage ("a Coeff");
    return retval;
  }

  octave_value X_arg = args(0);
  int nr= X_arg.rows();
  //  int nc= X_arg.columns();

  ColumnVector result (nr);

  for(int i= 0; i < nr; i++) {
    result(i)=1.0;
  }

  retval(0)=result;
  
  return retval;
}


DEFUN_DLD (bF, args, , "[...] = bF (...) bla ")
{
  octave_value_list retval;
  int nargin = args.length ();
  if (nargin >1 ) {
    print_usage ("b Coeff");
    return retval;
  }

  octave_value X_arg = args(0);
  int nr= X_arg.rows();

  ColumnVector result (nr);

  for(int i= 0; i < nr; i++) {
    result(i)=0.0;
  }

  retval(0)=result;
  
  return retval;
}


DEFUN_DLD (gD, args, , "[...] = gD (...) bla ")
{
  octave_value_list retval;
  int nargin = args.length ();
  if (nargin >1 ) {
    print_usage ("gD RHS");
    return retval;
  }

  octave_value X_arg = args(0);
  int nr= X_arg.rows(); 
  Matrix xy=X_arg.matrix_value();

  ColumnVector result (nr);

  for(int i= 0; i < nr; i++) {
    result(i)= xy(i,0)*xy(i,1);
  }

  retval(0)=result;
  
  return retval;
}


DEFUN_DLD (gN, args, , "[...] = gN (...) bla ")
{
  octave_value_list retval;
  int nargin = args.length ();
  if (nargin >1 ) {
    print_usage ("gN");
    return retval;
  }

  octave_value X_arg = args(0);
  int nr= X_arg.rows();
  //  int nc= X_arg.columns();

  ColumnVector result (nr);

  for(int i= 0; i < nr; i++) {
    result(i)= 0.0;
  }

  retval(0)=result;
  
  return retval;
}

